{-
 *  Programmer:	Piotr Borek
 *  E-mail:     piotrborek@op.pl
 *  Copyright 2018 Piotr Borek
 *
 *  Distributed under the terms of the GPL (GNU Public License)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-}

module Simple.UI.Widgets.Properties.Selected (
    HasSelected,
    selected,
    selectedGetColors
) where

import qualified Graphics.Vty                  as Vty

import           Simple.UI.Core.Attribute
import           Simple.UI.Core.Draw
import           Simple.UI.Core.Internal.UIApp
import           Simple.UI.Widgets.Widget

class WidgetClass w => HasSelected w where
    selected :: w -> Attribute Bool

    selectedGetColors :: w -> UIApp u (Vty.Color, Vty.Color, DrawStyle)
    selectedGetColors widget = do
        sel <- get widget selected
        if sel
            then do
                fg <- get widget colorForegroundSelected
                bg <- get widget colorBackgroundSelected
                style <- get widget colorStyleSelected
                return (fg, bg, style)
            else do
                fg <- get widget colorForeground
                bg <- get widget colorBackground
                style <- get widget colorStyle
                return (fg, bg, style)
